/*
  CPP_CONTEST=2013
  CPP_PROBLEM=F
  CPP_LANG=C+OPENMP
  CPP_PROCESSES_PER_NODE=jupiter 1
*/

/* RECORD
Juan Pedro López Navarro
students of the University of Murcia
time 4657 msec
speed-up 21.75
*/ 

/*A group of threads searches through the tree.
One thread (single) begins the search,
and tasks are generated for each new node in the tree.
Each thread works with a private optimum value,
and the maximum is obtained sequential
when the slave threads have finished.
*/

#include <stdlib.h>
#include <stdio.h>
#include <omp.h>

int NUM_HILOS;

void escribir(int nivel,int nw,int nt,int *s,int *asig,int Bact)
{
  int i;

  printf("  en nivel: %d\n",nivel);
  printf("  solucion con beneficio %d: ",Bact);
  for(i=0;i<nt;i++)
    printf("%d , ",s[i]);
  printf("\n");
  printf("  asignados: ");
  for(i=0;i<nw;i++)
    printf("%d , ",asig[i]);
  printf("\n");
  scanf("%d\n",&i);
}

int solution(int nivel,int nw,int nt,int *b,int *c,int *s,int *asig)
{
//solution if in the last level and restrictions are fulfilled
  return( (nivel==nt-1) && (b[s[nivel]*nt+nivel]!=0) && (asig[s[nivel]]<=c[s[nivel]]) );
}

int value(int nw,int nt,int *b,int *s)
{
  int v=0,i;

  for(i=0;i<nt;i++)
    v+=b[s[i]*nt+i];
  return v;
}

int criterio(int nivel,int nw,int nt,int *b,int *c,int *s,int *asig,int Bact,int *Bmax,int VOA)
{
//sons can be generated if not in the last level and restrictions are fulfilled
  return( (nivel<nt-1) && (b[s[nivel]*nt+nivel]!=0) && (asig[s[nivel]]<=c[s[nivel]]) && (Bact+Bmax[nivel+1]>VOA));
}

int more(int nivel,int nw,int nt,int *b,int *c,int *s,int *asig)
{
//if not all the possible assignations of workers to the tasks have been evaluated
  return( s[nivel]!=nw-1 );
}

void  generate(int nivel,int nw,int nt,int *b,int *c,int *s,int *asig,int *Bact)
{
//if not the first son, decrease the number of asignations to the worker
  if(s[nivel]!=-1)
  {
    asig[s[nivel]]--;
    *Bact-=b[s[nivel]*nt+nivel];
  }
//assign next worker to the task
  s[nivel]++;
  asig[s[nivel]]++;
  *Bact+=b[s[nivel]*nt+nivel];
}

void  retrocede(int *nivel,int nw,int nt,int *b,int *c,int *s,int *asig,int *Bact)
{
  *Bact-=b[s[*nivel]*nt+*nivel];
  //asig[s[*nivel]]--;
  s[*nivel]=-1;
  //(*nivel)--;
}

//nw numWorkers, nt numTareas, b beneficios, c capacidades, VOA, next_nivel, array next_sol de nt, *BMax, BAct, 

void recorrer(int nw, int nt, int *b, int *c, int *VOA, int nivel, int *sol, int *BMax, int beneficio, int *asig){
  
  
  int i;
  
  /*for(i=0; i<nt; i++)
    printf("%d ",sol[i]);
  printf("\n");*/
  //generate(nivel,nw,nt,b,c,sol,asig,&beneficio);
  
  
    do
    {
      if(more(nivel,nw,nt,b,c,sol,asig)){
        generate(nivel,nw,nt,b,c,sol,asig,&beneficio);
        if(solution(nivel,nw,nt,b,c,sol,asig))
        {
           if(beneficio>VOA[omp_get_thread_num()])
           {
              VOA[omp_get_thread_num()]=beneficio;
              #pragma omp critical
              {
                if(VOA[omp_get_thread_num()]>VOA[NUM_HILOS])
                  VOA[NUM_HILOS]=VOA[omp_get_thread_num()];
              }
           }
        }
      }
      //printf("Estoy en nivel:%d Hermano:%d Nodo:%d \n",nivel,sol[nivel],omp_get_thread_num());
      if(criterio(nivel,nw,nt,b,c,sol,asig,beneficio,BMax,VOA[NUM_HILOS]))
      {        
          int next_nivel = nivel+1;
          int next_beneficio = beneficio;
          int *next_sol=(int *) malloc(sizeof(int)*nt);
          for(i=0; i<nt; i++)
            next_sol[i]=sol[i];
                     
          int *asig_next=(int *) malloc(sizeof(int)*nw);     
          for(i=0;i<nw;i++)
            asig_next[i]=asig[i]; 
      
          #pragma omp task firstprivate(nw, nt, b, c, VOA, next_nivel, next_sol, BMax, next_beneficio, asig_next)
            recorrer(nw, nt, b, c, VOA, next_nivel, next_sol, BMax, next_beneficio, asig_next);
        
      }
    } while (more(nivel,nw,nt,b,c,sol,asig));
    
    free(asig);
    free(sol);
  
  
}

int sec(int nw,int nt,int *b,int *c)
{
  int i,j,max; 
  NUM_HILOS = omp_get_max_threads();
  int VOA [NUM_HILOS+1];
  for(i=0; i<NUM_HILOS+1; i++)
    VOA[i]=-1;
  int Bact=0; //the benefit with the solution in the node
  int nivel=0; //nivel in the backtracking tree 
  int *Bmax; //stores the maximum beneficit from one task to the end

  Bmax=(int *) malloc(sizeof(int)*nt);
  //Initially no workers are assigned to the tasks
  for(i=0;i<nt;i++)
  {
    max=0;
    for(j=0;j<nw;j++)
    {
       if(b[j*nt+i]>max)
         max=b[j*nt+i];
    }
    Bmax[i]=max;

  }
  for(i=nt-2;i>=0;i--)
    Bmax[i]=Bmax[i]+Bmax[i+1]; 
   
    
  #pragma omp parallel shared (nw, nt, b, c, VOA, Bact, nivel, NUM_HILOS, Bmax) private(i,j,max)
  {
          #pragma omp single nowait
          {
              int *sol=(int *) malloc(sizeof(int)*nt);
              sol[0]=-1;
              for(i=1;i<nt;i++)
                sol[i]=-1;
              int *asig=(int *) malloc(sizeof(int)*nw);     
              for(i=0;i<nw;i++)
                asig[i]=0;   

//nw numWorkers, nt numTareas, b beneficios, c capacidades, VOA, next_nivel, array next_sol de nt, *BMax, BAct, asig
              recorrer(nw, nt, b, c, VOA, 0, sol, Bmax, 0, asig);
          }
    }
    int max_VOA;
    max_VOA=VOA[0];
    for (i=1; i<NUM_HILOS+1; i++)
    {
        if (max_VOA < VOA[i])
           max_VOA = VOA[i];
    }
    return max_VOA;
}
